﻿#include <iostream>
#include <vector>
using namespace std;

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

struct Input {
	vector<double> numbers;
	size_t bin_count{};
};
Input
input_data() {
	size_t number_count;
	cin >> number_count;
	Input in;
	in.numbers.resize(number_count);
	for (size_t i = 0; i < number_count; i++) {
		cin >> in.numbers[i];
	}
	cin >> in.bin_count;
	return in;
}
void find_minmax(const vector<double>& numbers, double& min, double& max){
	min = numbers[0];
	max = numbers[0];
	for (double x : numbers) {
		if (x < min) {
			min = x;
		}
		else if (x > max) {
			max = x;
		}
	}
}

vector<size_t> make_histogram(const vector<double>& numbers, size_t bin_count)
{
	double min, max;
	find_minmax(numbers, min, max);

	vector<size_t> bins(bin_count);
	double bin_size = (max - min) / bin_count;

	for (double num : numbers) {
		bool found = false;
		for (size_t j = 0; j < bin_count - 1 && !found; j++) {
			double lo = min + j * bin_size;
			double hi = min + (j + 1) * bin_size;
			if (lo <= num && num < hi) {
				bins[j]++;
				found = true;
			}
		}
		if (!found) {
			bins[bin_count - 1]++;
		}
	}
	return bins;
}

void show_histogram_text(vector<size_t> bins, size_t bin_count)
{
	double max_count = bins[0];
		for (double x : bins) {
			if (x > max_count) {
				max_count = x;
			}
		}
		size_t height;
		bool flag = true;
		for (size_t j = 0; j < bin_count; j++) {
			if (bins[j] < 100) {
				cout << " ";
			}
			if (bins[j] < 10) {
				cout << " ";
			}
			cout << bins[j] << "|";
			if (max_count > MAX_ASTERISK) {
				for (size_t i = 0; i < bins[j]; i++) {
					if (bins[j] != MAX_ASTERISK && flag) {
						double count = bins[j];
						height = MAX_ASTERISK * (static_cast<double>(count) / max_count);
						bins[j] = height;
						flag = false;
					}
				}
			}
			for (size_t i = 0; i < bins[j]; i++) {
				cout << "*";
			}
			cout << endl;
			flag = true;
		}
}

int main()
{
	Input in = input_data();
	auto bins = make_histogram(in.numbers, in.bin_count);
	show_histogram_text(bins,in.bin_count);
	return 0;
}
